#!/bin/bash

# cd to deployment directory
# This dir is assumed to contain current copys of:
# mod_WebObjects.la 
# mod_WebObjects.so 
# sslcerts.tar 
# apache.conf
cd /Users/netbrackets/deploy

# Main script for building a WebObjects deployment environment. Note that this script does NOT start
# WebObjects services. That is left to the whatever calls this script because the chances are the 
# calling script will want to do some more stuff to the environment before booting WebObjects.

# Install required packages
echo "Installing required packages (httpd, httpd-devel, mod_ssl)"
brew install wget
brew install httpd24
brew install httpd24-devel
brew install mod_ssl
brew install git
brew install openldap libiconv

#Kill the Mac version of apache httpd
sudo apachectl stop
sudo launchctl unload -w /System/Library/LaunchDaemons/org.apache.httpd.plist 2>/dev/null

#Start homebrew version of apache
sudo brew services start httpd

#Ted's link
#installing the newer Java JDK
#wget --no-cookies --no-check-certificate --header "Cookie: gpw_e24=http%3A%2F%2Fwww.oracle.com%2F; oraclelicense=accept-securebackup-cookie" "http://download.oracle.com/otn-pub/java/jdk/8u131-b11/d54c1d3a095b4ff2b6607d096fa80163/jdk-8u131-linux-x64.tar.gz"
#tar zpxf jdk-8u131-linux-x64.tar.gz
#rm jdk-8u131-linux-x64.tar.gz
#

#My download link, had to change https to http. Also, I installed it manually so didn't actuall run this.
#wget --no-cookies --no-check-certificate --header "Cookie: gpw_e24=http%3A%2F%2Fwww.oracle.com%2F; oraclelicense=accept-securebackup-cookie" "http://download.oracle.com/otn-pub/java/jdk/11.0.1+13/90cf5d8f270a4347a95050320eef3fb7/jdk-11.0.1_osx-x64_bin.tar.gz"

# This was for CENT OS
#alternatives --install /usr/bin/jar jar /opt/jdk1.8.0_131/bin/jar 2
#alternatives --install /usr/bin/javac javac /opt/jdk1.8.0_131/bin/javac 2
#alternatives --set jar /opt/jdk1.8.0_131/bin/jar
#alternatives --set javac /opt/jdk1.8.0_131/bin/javac

#For MAC OS
#JDKs installed at /Library/Java/JavaVirtualMachines/jdkMAJOR.MINOR.MACRO_UPDATE.jdk
#where MAJOR, MINOR, MACRO, UPDATE are the corresponding numbers of Java version.
#So to switch version, use the following command,
#/usr/libexec/java_home -v MAJOR.MINOR.MACRO_UPDATE
sudo /usr/libexec/java_home -v 11.0.1 

# CENT OS
# Set required environment variables
#echo "Setting required environment variables"
#touch /home/ec2-user/.bash_profile
#cat >> /home/ec2-user/.bash_profile << END
#PATH=$PATH:/opt/jdk1.8.0_131/bin:/opt/jdk1.8.0_131/jre/bin; export PATH
#END

# MAC OS (didn't see a jre/bin dir.
# Set required environment variables
echo "Setting required environment variables"
touch /Users/netbrackets/.bash_profile
echo "export PATH=\$PATH:/Library/Java/JavaVirtualMachines/jdk-11.0.1.jdk/Contents/Home/bin;" >> /Users/netbrackets/.bash_profile

# CENT OS
# Install the WebObjects adaptor (note: we use the 54 builds, but you can run 53 apps under these)
#echo "Installing the WebObjects adaptor"
#yum -y install gcc
#yum -y install make
#mkdir wonder
#cd wonder
#use git to clone the wonder repository into WonderSource
#git clone git://github.com/wocommunity/wonder.git WonderSource
#cd WonderSource
#chmod -R 777 Utilities
## Build the adaptor
#echo "Building the adaptor"
#cd Utilities/Adaptors
#sed --in-place=.backup 's/ADAPTOR_OS = MACOS/ADAPTOR_OS = LINUX/g' make.config
#make CC=gcc
#cd Apache2.4/
#apxs -i -a -n WebObjects mod_WebObjects.la

# MAC OS I TRIED THIS BUT GOT LINKER ERRORS
## Install the WebObjects adaptor (note: we use the 54 builds, but you can run 53 apps under these)
##echo "Installing the WebObjects adaptor"
#brew install gcc
#brew install make
#mkdir wonder
#cd wonder
##use git to clone the wonder repository into WonderSource
#git clone git://github.com/wocommunity/wonder.git WonderSource
#cd WonderSource
#chmod -R 777 Utilities
## Build the adaptor
#echo "Building the adaptor"
#cd Utilities/Adaptors
#gmake CC=gcc
#cd Apache2.4/
#apxs -i -a -n WebObjects mod_WebObjects.la

#Copying exsiting adaptor files instead of building new
sudo cp mod_WebObjects.so /usr/local/etc/httpd/modules/
sudo cp mod_WebObjects.la /usr/local/etc/httpd/modules/
# Install a modified webobjects.conf.
echo "Installing a modified webobjects.conf"
sudo cp webobjects.conf /usr/local/etc/httpd/conf.d/webobjects.conf

## Tidy up
#cd ~
#rm -r WonderSource

# CENT OS
## Add WO stuff to httpd.conf
#echo "Modifying httpd.conf to support WebObjects"
#cat >> /etc/httpd/conf/httpd.conf << END

#Alias /WebObjects "/opt/WOWebServerResources/WebObjects"

#<Directory "/opt/WOWebServerResources/WebObjects">
#      AllowOverride All
#      Order allow,deny
#      Allow from all
#</Directory>
#
#<LocationMatch /apps/WebObjects/.*>
#    Order allow,deny
#    Allow from all
#</LocationMatch>
#END

# MAC OS - JUST COPYING AN EXISTING ONE FROM EXISTING SERVER
sudo cp httpd.conf /usr/local/etc/httpd/

# Boot Apache
echo "Booting Apache"
sudo apachectl restart

# Change the open file limits of the OS (defaults are stingy)

#CENT OS
#echo "Modifying the operating system's open file limits"
#cat >> /etc/sysctl.conf << END
#fs.file-max=200000
#END
#cat >> /etc/security/limits.conf << END
#* hard nofile 200000
#* soft nofile 200000
#END
#cat >> /etc/security/limits.conf << END
#session    required     pam_limits.so
#END
# Reload system props
#sysctl -p


# MAC OS
# https://gist.github.com/tombigel/d503800a282fcadbee14b537735d202c
curl -O https://gist.githubusercontent.com/tombigel/d503800a282fcadbee14b537735d202c/raw/ed73cacf82906fdde59976a0c8248cce8b44f906/limit.maxfiles.plist
curl -O https://gist.githubusercontent.com/tombigel/d503800a282fcadbee14b537735d202c/raw/ed73cacf82906fdde59976a0c8248cce8b44f906/limit.maxproc.plist

sudo mv limit.maxfiles.plist /Library/LaunchDaemons
sudo mv limit.maxproc.plist /Library/LaunchDaemons

sudo chown root:wheel /Library/LaunchDaemons/limit.maxfiles.plist
sudo chown root:wheel /Library/LaunchDaemons/limit.maxproc.plist

sudo launchctl load -w /Library/LaunchDaemons/limit.maxfiles.plist
sudo launchctl load -w /Library/LaunchDaemons/limit.maxproc.plist


# CENT OS
## Add user and group
#echo "Adding appserveradm group and appserver user"
#sudo groupadd appserveradm
#sudo seradd -g appserveradm appserver

# MAC OS
# They exist by default, but with underscores prepended

# Make require dirs
echo "Creating required directory structures in /usr/local/opt"
sudo mkdir /usr/local/opt/WOApplications
sudo mkdir /usr/local/opt/WOWebServerResources
sudo mkdir /usr/local/opt/WOWebServerResources/WebObjects
sudo mkdir /usr/local/opt/WODeployment
sudo mkdir /usr/local/opt/WODeployment/Configuration


# CENT OS
## Get fully-embedded JavaMonitor and wotaskd (note: this comes from the nightly builds)
#echo "Installing fully-embeded JavaMonitor and wotaskd from the Wonder Jenkins server"
#wget https://jenkins.wocommunity.org/job/Wonder7/lastSuccessfulBuild/artifact/Root/Roots/JavaMonitor.tar.gz --no-check-certificate
#mv JavaMonitor.tar.gz /opt/WODeployment/JavaMonitor.tar.gz
#tar zpxf /opt/WODeployment/JavaMonitor.tar.gz -C /opt/WODeployment/
#rm /opt/WODeployment/JavaMonitor.tar.gz
#wget https://jenkins.wocommunity.org/job/Wonder7/lastSuccessfulBuild/artifact/Root/Roots/wotaskd.tar.gz --no-check-certificate
#mv wotaskd.tar.gz /opt/WODeployment/wotaskd.tar.gz
#tar zpxf /opt/WODeployment/wotaskd.tar.gz -C /opt/WODeployment/
#rm /opt/WODeployment/wotaskd.tar.gz

# MAC OS
# Get fully-embedded JavaMonitor and wotaskd (note: this comes from the nightly builds)
echo "Installing fully-embeded JavaMonitor and wotaskd from the Wonder Jenkins server"
wget https://jenkins.wocommunity.org/job/Wonder7/lastSuccessfulBuild/artifact/Root/Roots/JavaMonitor.tar.gz --no-check-certificate
sudo mv JavaMonitor.tar.gz /usr/local/opt/WODeployment/JavaMonitor.tar.gz
sudo tar zpxf /usr/local/opt/WODeployment/JavaMonitor.tar.gz -C /usr/local/opt/WODeployment/
sudo rm /usr/local/opt/WODeployment/JavaMonitor.tar.gz
wget https://jenkins.wocommunity.org/job/Wonder7/lastSuccessfulBuild/artifact/Root/Roots/wotaskd.tar.gz --no-check-certificate
sudo mv wotaskd.tar.gz /usr/local/opt/WODeployment/wotaskd.tar.gz
sudo tar zpxf /usr/local/opt/WODeployment/wotaskd.tar.gz -C /usr/local/opt/WODeployment/
sudo rm /usr/local/opt/WODeployment/wotaskd.tar.gz

# CENT OS
## Modify JavaMonitor and wotaskd properties to use our custom layout
#echo "Modifying JavaMonitor and wotaskd properties to accommodate custom directory structure"
#cat >> /opt/WODeployment/JavaMonitor.woa/Contents/Resources/Properties << END

#WODeploymentConfigurationDirectory=/opt/WODeployment/Configuration
#WOLocalRootDirectory=/opt
#END
#cat >> /opt/WODeployment/wotaskd.woa/Contents/Resources/Properties << END

#WODeploymentConfigurationDirectory=/opt/WODeployment/Configuration
#WOLocalRootDirectory=/opt
#END

## Fix user and group
#echo "Fixing users and groups"
#chown -R appserver:appserveradm /opt/WOApplications
#chown -R appserver:appserveradm /opt/WOWebServerResources
#chown -R appserver:appserveradm /opt/WODeployment




# MAC OS
# Fix user and group
echo "Fixing users and groups"
sudo chown -R _appserver:_appserveradm /usr/local/opt/WOApplications
sudo chown -R _appserver:_appserveradm /usr/local/opt/WOWebServerResources
sudo chown -R _appserver:_appserveradm /usr/local/opt/WODeployment

# Modify JavaMonitor and wotaskd properties to use our custom layout
echo "Modifying JavaMonitor and wotaskd properties to accommodate custom directory structure"
cp /usr/local/opt/WODeployment/JavaMonitor.woa/Contents/Resources/Properties .
cat >> Properties << END

WODeploymentConfigurationDirectory=/usr/local/opt/WODeployment/Configuration
WOLocalRootDirectory=/usr/local/opt
END
sudo mv Properties /usr/local/opt/WODeployment/JavaMonitor.woa/Contents/Resources/Properties 
sudo chown _appserver:_appserveradm /usr/local/opt/WODeployment/JavaMonitor.woa/Contents/Resources/Properties 

cp /usr/local/opt/WODeployment/wotaskd.woa/Contents/Resources/Properties .
cat >> Properties << END

WODeploymentConfigurationDirectory=/usr/local/opt/WODeployment/Configuration
WOLocalRootDirectory=/usr/local/opt
END
sudo mv Properties /usr/local/opt/WODeployment/wotaskd.woa/Contents/Resources/Properties 
sudo chown _appserver:_appserveradm /usr/local/opt/WODeployment/wotaskd.woa/Contents/Resources/Properties 



## CENT OS
## Fix permissions
#echo "Fixing permissions"
#chmod 750 /opt/WODeployment/JavaMonitor.woa/JavaMonitor
#chmod 750 /opt/WODeployment/wotaskd.woa/Contents/Resources/SpawnOfWotaskd.sh
#chmod 750 /opt/WODeployment/wotaskd.woa/wotaskd

# MAC OS
# Fix permissions
echo "Fixing permissions"
sudo chmod 750 /usr/local/opt/WODeployment/JavaMonitor.woa/JavaMonitor
sudo chmod 750 /usr/local/opt/WODeployment/wotaskd.woa/Contents/Resources/SpawnOfWotaskd.sh
sudo chmod 750 /usr/local/opt/WODeployment/wotaskd.woa/wotaskd

## CENT OS
## Set required environment variables
#echo "Setting required environment variables"
#touch /home/appserver/.bash_profile
#cat >> /home/appserver/.bash_profile << END
#NEXT_ROOT=/opt; export NEXT_ROOT
#WOROOT=/opt; export WOROOT
#END

# MAC OS
# Set required environment variables

# --------------------- I AM HERE ------------------
## CENT OS
## Add a boot script for WO Deployment
#echo "Addint a stock initd script for WebObjects services"
##wget http://webobjects.s3.amazonaws.com/wo-webobjects.initd -O /etc/init.d/webobjects
#
#echo "Creating webobjects in /etc/init.d/"
#touch /etc/init.d/webobjects
#cat >> /etc/init.d/webobjects<< END
##!/bin/bash
#
## chkconfig: - 90 20
## description: Provides WebObjects services
#
## Source function library.
#. /etc/rc.d/init.d/functions

#NEXT_ROOT="/opt"
#export NEXT_ROOT

#USER=appserver

# MAC OS
# Add a boot script for WO Deployment
echo "Addint a stock initd script for WebObjects services"
#wget http://webobjects.s3.amazonaws.com/wo-webobjects.initd -O /etc/init.d/webobjects

echo "Creating webobjects in /etc/init.d/"
touch /etc/init.d/webobjects
cat >> /etc/init.d/webobjects<< END
#!/bin/bash

# chkconfig: - 90 20
# description: Provides WebObjects services

# Source function library.
. /etc/rc.d/init.d/functions

NEXT_ROOT="/opt"
export NEXT_ROOT

USER=appserver

## CENT OS
## See how we were called.
#case "$1" in
#	start)
#              	echo -n "Starting wotaskd and Monitor: "
#                su $USER -c "$NEXT_ROOT/WODeployment/wotaskd.woa/wotaskd -WOPort 1085 &"
#                su $USER -c "$NEXT_ROOT/WODeployment/JavaMonitor.woa/JavaMonitor -WOPort 56789 &"
#                echo
#                ;;
#        stop)
#             	echo -n "Shutting down wotaskd and Monitor: "
#                WOTASKD_PID=`ps aux | awk '/WOPort 1085/ && !/awk/ {print $2}'`
#                kill $WOTASKD_PID
#                MONITOR_PID=`ps aux | awk '/WOPort 56789/ && !/awk/ {print $2}'`
#                kill $MONITOR_PID
#                echo
#                ;;
#        restart)
#                $0 stop
#                $0 start
#                ;;
#		status)
#				WOTASKD_PID=`ps aux | awk '/WOPort 1085/ && !/awk/ {print $2}'`
#				echo -n "wotaskd is running with PID " WOTASKD_PID
#				MONITOR_PID=`ps aux | awk '/WOPort 56789/ && !/awk/ {print $2}'`
#				echo -n "JavaMonitor is running with PID " MONITOR_PID
#				;
#				;
#        *)
#          	echo -n "Usage: $0 {start|stop|restart}"
#                exit 1
#esac

#if [ $# -gt 1 ]; then
#        shift
#	$0 $*
#fi
#
#exit 0
#
#END

# MAC OS
# See how we were called.
case "$1" in
	start)
              	echo -n "Starting wotaskd and Monitor: "
                su $USER -c "$NEXT_ROOT/WODeployment/wotaskd.woa/wotaskd -WOPort 1085 &"
                su $USER -c "$NEXT_ROOT/WODeployment/JavaMonitor.woa/JavaMonitor -WOPort 56789 &"
                echo
                ;;
        stop)
             	echo -n "Shutting down wotaskd and Monitor: "
                WOTASKD_PID=`ps aux | awk '/WOPort 1085/ && !/awk/ {print $2}'`
                kill $WOTASKD_PID
                MONITOR_PID=`ps aux | awk '/WOPort 56789/ && !/awk/ {print $2}'`
                kill $MONITOR_PID
                echo
                ;;
        restart)
                $0 stop
                $0 start
                ;;
		status)
				WOTASKD_PID=`ps aux | awk '/WOPort 1085/ && !/awk/ {print $2}'`
				echo -n "wotaskd is running with PID " WOTASKD_PID
				MONITOR_PID=`ps aux | awk '/WOPort 56789/ && !/awk/ {print $2}'`
				echo -n "JavaMonitor is running with PID " MONITOR_PID
				;
				;
        *)
          	echo -n "Usage: $0 {start|stop|restart}"
                exit 1
esac

if [ $# -gt 1 ]; then
        shift
	$0 $*
fi

exit 0

END


# CENT OS
## Fix the permissions
#echo "Fixing permissions"
#chmod 755 /etc/init.d/webobjects

## Add the service and switch it on
#echo "Adding the WebObjects service and turning it on"
#chkconfig --add webobjects
#chkconfig webobjects on

# MAC OS
sudo cp com.apple.webobjects.wotaskd.plist /Library/LaunchDaemons/
sudo cp com.apple.webobjects.womonitor.plist /Library/LaunchDaemons/
sudo cp com.netbrackets.backupNB.plist /Library/LaunchDaemons/
sudo launchctl load /Library/LaunchDaemons/com.apple.webobjects.wotaskd.plist 
sudo launchctl load /Library/LaunchDaemons/com.apple.webobjects.womonitor.plist 
